
#ifndef __CHUNK_3DS__
#define __CHUNK_3DS__


#define CHUNK_SIZE				6


// Id
#define ID_CHUNK_M3D_MAGIC			0x4D4D
#define ID_CHUNK_M3D_VERSION		0x0002

#define ID_CHUNK_MESH_DATA			0x3D3D
#define ID_CHUNK_MESH_VERSION		0x3D3E
#define ID_CHUNK_MASTER_SCALE		0x0100

#define ID_CHUNK_KF_DATA			0xB000

#define ID_CHUNK_NAMEDOBJ			0x4000 // 1-10 CHAR + NULL
#define ID_CHUNK_OBJ_MESH			0x4100
#define ID_CHUNK_OBJ_VERTICES		0x4110
#define ID_CHUNK_OBJ_FACES			0x4120
#define ID_CHUNK_OBJ_MATERIAL		0x4130
#define ID_CHUNK_OBJ_TEXTURE		0x4140

#define ID_CHUNK_MAT_ENTRY			0xAFFF
#define ID_CHUNK_MAT_NAME			0xA000 // 1-15 CHAR + NULL
#define ID_CHUNK_MAT_AMBIENT		0xA010
#define ID_CHUNK_MAT_DIFFUSE		0xA020
#define ID_CHUNK_MAT_SPECULAR		0xA030
#define ID_CHUNK_MAT_SHININESS		0xA040
#define ID_CHUNK_MAT_SHIN2PCT		0xA041
#define ID_CHUNK_MAT_TRANSPARENCY	0xA050
#define ID_CHUNK_MAT_SHADING		0xA100

#define ID_CHUNK_TXT_ENTRY			0xA200
#define ID_CHUNK_TXT_NAME			0xA300 // 1-12 CHAR + NULL
#define ID_CHUNK_TXT_TILING			0xA351

#define ID_CHUNK_COLOR24			0x0011
#define ID_CHUNK_INT_PERCENTAGE		0x0030



// Size
#define SIZE_CHUNK_M3D_VERSION		(CHUNK_SIZE + sizeof(DWORD))
#define	SIZE_CHUNK_MESH_VERSION		(CHUNK_SIZE + sizeof(DWORD))
#define SIZE_CHUNK_MASTER_SCALE		(CHUNK_SIZE + sizeof(FLOAT))

#define SIZE_CHUNK_MESH_DATA		(CHUNK_SIZE + SIZE_CHUNK_MESH_VERSION + SIZE_CHUNK_MASTER_SCALE)
#define SIZE_CHUNK_M3D_MAGIC		(CHUNK_SIZE + SIZE_CHUNK_M3D_VERSION + SIZE_CHUNK_MESH_DATA)

#define SIZE_CHUNK_COLOR24			(CHUNK_SIZE + 3*sizeof(BYTE))
#define SIZE_CHUNK_INT_PERCENTAGE	(CHUNK_SIZE + sizeof(WORD))

#define SIZE_CHUNK_MAT_COLOR		(CHUNK_SIZE + SIZE_CHUNK_COLOR24)
#define SIZE_CHUNK_MAT_RATIO		(CHUNK_SIZE + SIZE_CHUNK_INT_PERCENTAGE)
#define SIZE_CHUNK_MAT_SHADING		(CHUNK_SIZE + sizeof(WORD))
#define SIZE_CHUNK_TXT_TILING		(CHUNK_SIZE + sizeof(WORD))

#define SIZE_CHUNK_MAT_NAME			CHUNK_SIZE // + Material Name size
#define SIZE_CHUNK_TXT_NAME			CHUNK_SIZE // + Texture Name size
#define SIZE_CHUNK_MAT_ENTRY		(CHUNK_SIZE + SIZE_CHUNK_MAT_NAME + 3*SIZE_CHUNK_MAT_COLOR + 3*SIZE_CHUNK_MAT_RATIO + SIZE_CHUNK_MAT_SHADING )  // + Material Name size
#define SIZE_CHUNK_TXT_ENTRY		(CHUNK_SIZE + SIZE_CHUNK_INT_PERCENTAGE + SIZE_CHUNK_TXT_NAME + SIZE_CHUNK_TXT_TILING) // + Texture Name size

#define SIZE_CHUNK_OBJ_VERTICES		(CHUNK_SIZE + sizeof(WORD))
#define SIZE_CHUNK_OBJ_TEXTURE		(CHUNK_SIZE + sizeof(WORD))
#define SIZE_CHUNK_OBJ_FACES		(CHUNK_SIZE + sizeof(WORD))
#define SIZE_CHUNK_OBJ_MATERIAL		(CHUNK_SIZE + sizeof(WORD)) // + Material Name size + MatFace
#define SIZE_CHUNK_OBJ_MESH			(CHUNK_SIZE + SIZE_CHUNK_OBJ_VERTICES + SIZE_CHUNK_OBJ_TEXTURE + SIZE_CHUNK_OBJ_FACES) // + VerCoord + TxtCoord + Face
#define SIZE_CHUNK_NAMEDOBJ			(CHUNK_SIZE + SIZE_CHUNK_OBJ_MESH) // + Mesh Name size + VerCoord + TxtCoord + Face


#endif  // __CHUNK_3DS__
